<script setup lang="ts">
import camiproImg from "@/assets/camipro.jpg";
import { useRoute, useRouter } from "vue-router";
import { onMounted, reactive } from "vue";
import { hydraGetConsentRequest, hydraPostConsentRequest } from "@/scripts/api-helper";

const SCOPE_MAP = {
  profile: {
    short: "PROFILE",
    description: "nom, image de profil, mail EPFL",
  },
  acad: {
    short: "ACADEMIQUE",
    description: "section, faculté",
  },
  perso: {
    short: "PERSO",
    description: "genre, mail personnel",
  },
  banking: {
    short: "BANQUE",
    description: "IBAN, addresse perso",
  },
};

const state = reactive({
  ready: false,
  client_name: null as string | null,
  unit: null as string | null,
  scopes: null as null | string[],
  justification: null as null | string,
});

const route = useRoute();
const consentChallenge = route.query.consent_challenge as string;

onMounted(() => {
  if (!consentChallenge) {
    useRouter().push({ name: "home" });
    return;
  }

  hydraGetConsentRequest({
    consent_challenge: consentChallenge,
  })
    .then((res) => {
      console.log(
        `routesHydraConsentRequestGetConsentRequest response:`,
        res.data
      );

      if (res.data.skip) {
        window.location.replace(res.data.redirect_to!);
        return;
      }

      state.client_name =
        res.data.consent_request.client?.client_id || "Application inconnue ?";
      state.unit = res.data.consent_request.client?.owner || "inconnue";
      state.justification = "Pas de justification";
      state.scopes =
        (res.data.consent_request.requested_scope as string[]) || null;
      state.ready = true;
    })
    .catch((err) => {
      if (err instanceof hydraGetConsentRequest.Error) {
        const error = err.getActualType();
        console.error("API ERROR:", error);
      }
    });
});

function submitConsent(consent: boolean) {
  hydraPostConsentRequest({
    consent,
    consent_challenge: consentChallenge,
  })
    .then((response) => {
      window.location.replace(response.data.redirect_to);
    })
    .catch((err) => {
      if (err instanceof hydraPostConsentRequest.Error) {
        const error = err.getActualType();
        console.error("API ERROR:", error);
      }
    });
}
</script>

<template>
  <main class="p-4">
    <div
      class="flex max-w-sm mx-auto overflow-hidden bg-white rounded-lg shadow-lg dark:bg-gray-800 lg:max-w-4xl"
    >
      <div class="hidden bg-cover lg:block lg:w-1/2 relative">
        <div class="bg-white/30 absolute w-full h-auto z-50">
          <img
            src="@/assets/agepoly-white.svg"
            class="h-auto w-full scale-75"
          />
        </div>
        <div
          class="hidden bg-cover lg:block w-full h-full"
          :style="{ backgroundImage: `url(${camiproImg})` }"
        ></div>
      </div>

      <div v-if="state.ready" class="w-full px-6 py-8 md:px-8 lg:w-1/2">
        <h2
          class="text-2xl font-semibold text-center text-gray-700 dark:text-white"
        >
          Whiskey
        </h2>

        <p class="text-xl text-center text-gray-600 dark:text-gray-200">
          Le SSO de l'AGEPoly !
        </p>

        <div
          class="p-5 mt-5 border rounded-xl border-r-gray-200 dark:border-gray-700"
        >
          <div class="flex items-start -mx-4 justify-center">
            <div class="mx-4 mt-0">
              <h1
                class="text-2xl font-bold text-gray-700 text-center w-full dark:text-white"
              >
                {{ state.client_name }}
              </h1>
              <h2>
                Unité: <strong>{{ state.unit }}</strong>
              </h2>
            </div>
          </div>
        </div>

        <p
          class="text-xs text-center text-gray-500 uppercase dark:text-gray-400 m-3"
        >
          utilise les données suivantes
        </p>

        <div
          class="p-5 mt-3 space-y-1.5 border-x-2 border-x-blue-400 dark:border-blue-300 rounded-xl"
        >
          <ul>
            <li v-for="scope of state.scopes" v-bind:key="scope">
              -
              <strong>{{
                (SCOPE_MAP[scope] && SCOPE_MAP[scope].short) ||
                scope.toUpperCase()
              }}</strong>
              <span v-if="SCOPE_MAP[scope]">
                - {{ SCOPE_MAP[scope].description || "Scope inconnu" }}</span
              >
            </li>
          </ul>
          <p class="text-gray-500 dark:text-gray-300">
            <strong>Justification</strong> <br />
            {{ state.justification }}
          </p>
        </div>

        <div class="mt-8">
          <button
            class="w-full px-4 py-2 tracking-wide text-white transition-colors duration-200 transform bg-green-600 rounded hover:bg-green-700"
            @click="submitConsent(true)"
          >
            J'accepte
          </button>
        </div>
        <div class="mt-1">
          <button
            class="w-full px-4 py-1 tracking-wide text-white transition-colors duration-200 transform bg-red-400 rounded hover:bg-red-500"
            @click="submitConsent(false)"
          >
            Je refuse
          </button>
        </div>

        <div class="flex items-center justify-between mt-4">
          <span class="w-1/5 border-b dark:border-gray-600 md:w-1/4"></span>

          <router-link
            to="/help"
            class="text-xs text-gray-500 uppercase dark:text-gray-400 hover:underline"
            >J'ai besoin d'aide</router-link
          >

          <span class="w-1/5 border-b dark:border-gray-600 md:w-1/4"></span>
        </div>
      </div>
    </div>
  </main>
</template>
